## supertuxkart 1.1+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.4)

# root CMakeLists for the SuperTuxKart project
project(SuperTuxKart)
set(PROJECT_VERSION "1.1")
add_definitions( -DSUPERTUXKART_VERSION="${PROJECT_VERSION}" )

if(NOT (CMAKE_MAJOR_VERSION VERSION_LESS 3))
  cmake_policy(SET CMP0043 OLD)
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")
include(CMakeDependentOption)

include(BuildTypeSTKRelease)
if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "No build type selected, default to STKRelease")
    set(CMAKE_BUILD_TYPE "STKRelease")
endif()

option(SERVER_ONLY "Create a server only (i.e. no graphics or sound)" OFF)
option(CHECK_ASSETS "Check if assets are installed in ../stk-assets" ON)
option(USE_SYSTEM_ANGELSCRIPT "Use system angelscript instead of built-in angelscript. If you enable this option, make sure to use a compatible version." OFF)
option(USE_SYSTEM_ENET "Use system ENet instead of the built-in version, when available." ON)
option(USE_IPV6 "Allow create or connect to game server with IPv6 address, system enet will not be used." ON)
option(USE_SYSTEM_GLEW "Use system GLEW instead of the built-in version, when available." ON)
option(USE_SYSTEM_WIIUSE "Use system WiiUse instead of the built-in version, when available." OFF)
option(USE_SQLITE3 "Use sqlite to manage server stats and ban list." ON)

option(USE_CRYPTO_OPENSSL "Use OpenSSL instead of Nettle for cryptography in STK." ON)
CMAKE_DEPENDENT_OPTION(BUILD_RECORDER "Build opengl recorder" ON
    "NOT SERVER_ONLY;NOT APPLE" OFF)
CMAKE_DEPENDENT_OPTION(USE_SYSTEM_SQUISH "Use system Squish library instead of the built-in version, when available." ON
    "NOT SERVER_ONLY" OFF)
CMAKE_DEPENDENT_OPTION(USE_WIIUSE "Support for wiimote input devices" ON
    "NOT SERVER_ONLY;NOT CYGWIN" OFF)

if(APPLE AND NOT IOS)
    list(APPEND CMAKE_PREFIX_PATH /usr/local/opt)
    include_directories(/usr/local/opt/fribidi/include/)
    include_directories(/usr/local/opt/openssl@1.1/include/)
    include_directories(/usr/local/opt/openssl@1.1/include/openssl/)
    include_directories(/usr/local/opt/freetype/include/freetype2/)
    include_directories(/usr/local/opt/harfbuzz/include/harfbuzz/)
endif()

if (IOS)
    ADD_DEFINITIONS(-DMOBILE_STK)
    ADD_DEFINITIONS(-DIOS_STK)
    set(CMAKE_XCODE_ATTRIBUTE_TARGETED_DEVICE_FAMILY "1,2")
    option(USE_GLES2 "Use OpenGL ES2 renderer" ON)
    find_library(RESOLV_LIBRARY NAMES resolv libresolv)
endif()

if((UNIX AND NOT APPLE) AND NOT SERVER_ONLY)
    option(ENABLE_WAYLAND_DEVICE "Enable Wayland device for linux build" ON)
    
    if((${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm") OR 
       (${CMAKE_SYSTEM_PROCESSOR} MATCHES "aarch64"))
        option(USE_GLES2 "Use OpenGL ES2 renderer" ON)
    else()
        option(USE_GLES2 "Use OpenGL ES2 renderer" OFF)
    endif()

endif()

if(UNIX OR MINGW)
    option(DEBUG_SYMBOLS "Compile with debug symbols" OFF)
endif()

if(MSVC AND (MSVC_VERSION LESS 1900))
    # Normally hide the option to build wiiuse on VS, since it depends
    # on the installation of the Windows DDK (Driver Developer Kit),
    # which also needs an absolute path :(
    option(WIIUSE_BUILD "Build wiiuse lib (only for developers)" OFF)
    mark_as_advanced(WIIUSE_BUILD)
else()
    set(WIIUSE_BUILD ON)
endif()

if(UNIX AND NOT APPLE)
    option(USE_ASAN   "Build with Leak/Address sanitizer" OFF)
    option(USE_LIBBFD "Use libbfd for crash reporting and leak check" OFF)
endif()

set(STK_SOURCE_DIR "src")
set(STK_DATA_DIR "${PROJECT_SOURCE_DIR}/data")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin")

# Define install paths
set(STK_INSTALL_BINARY_DIR "bin" CACHE
    STRING "Install executable to this directory, absolute or relative to CMAKE_INSTALL_PREFIX")
set(STK_INSTALL_DATA_DIR "share/supertuxkart" CACHE
    STRING "Install data folder to this directory, absolute or relative to CMAKE_INSTALL_PREFIX")

# Define dependencies path
if(MSVC)
    set(DEPENDENCIES "dependencies-vs")
elseif(MINGW)
    set(DEPENDENCIES "dependencies-mingw")
else()
    set(DEPENDENCIES "dependencies")
endif()

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(DEPENDENCIES "${DEPENDENCIES}-64bit")
endif()

if(WIN32)
    ADD_DEFINITIONS(-DUNICODE)
    ADD_DEFINITIONS(-D_UNICODE)
    if(NOT IS_DIRECTORY "${PROJECT_SOURCE_DIR}/${DEPENDENCIES}")
        set(DEPENDENCIES "dependencies")
        if(CMAKE_SIZEOF_VOID_P EQUAL 8)
            set(DEPENDENCIES "${DEPENDENCIES}-64bit")
        endif()
    endif()

    if(NOT IS_DIRECTORY "${PROJECT_SOURCE_DIR}/${DEPENDENCIES}")
        message(FATAL_ERROR "Dependencies directory not found.")
    endif()
endif()

# These variables enable MSVC to find libraries located in "dependencies"
if(WIN32)
    set(ENV{PATH} "$ENV{PATH};${PROJECT_SOURCE_DIR}/${DEPENDENCIES}/include")
    set(ENV{LIB} ${PROJECT_SOURCE_DIR}/${DEPENDENCIES}/lib)
    set(ENV{OPENALDIR} ${PROJECT_SOURCE_DIR}/${DEPENDENCIES})
    add_definitions(-D_IRR_STATIC_LIB_)
    add_definitions(-DNO_IRR_COMPILE_WITH_X11_)
    include_directories(${PROJECT_SOURCE_DIR}/${DEPENDENCIES}/include)
endif()

if(USE_GLES2)
    add_definitions(-DUSE_GLES2)
    add_definitions(-D_IRR_COMPILE_WITH_OGLES2_ -DNO_IRR_COMPILE_WITH_OPENGL_)
endif()

if(SERVER_ONLY)
    add_definitions(-DSERVER_ONLY)
    add_definitions(-DNO_IRR_COMPILE_WITH_X11_ -DNO_IRR_COMPILE_WITH_OPENGL_)
endif()

if(UNIX OR MINGW)
    if(DEBUG_SYMBOLS)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g")
    endif()
endif()

if(UNIX AND NOT APPLE)
    find_package(PkgConfig REQUIRED)

    if(NOT PKGCONFIG_FOUND)
        message(FATAL_ERROR "Pkg-config not found.")
    endif()
endif()

# Build the Bullet physics library
add_subdirectory("${PROJECT_SOURCE_DIR}/lib/bullet")
include_directories("${PROJECT_SOURCE_DIR}/lib/bullet/src")

# Find system ENet library or build it if missing
if((UNIX AND NOT APPLE) AND USE_SYSTEM_ENET AND NOT USE_IPV6)
    pkg_check_modules(ENET libenet>=1.3.4)
endif()

if (USE_IPV6)
   add_definitions(-DENABLE_IPV6)
endif()

if(ENET_FOUND AND NOT USE_IPV6)
    include_directories(${ENET_INCLUDE_DIRS})
else()
    # Fallback to built-in version
    add_subdirectory("${PROJECT_SOURCE_DIR}/lib/enet")
    include_directories("${PROJECT_SOURCE_DIR}/lib/enet/include")
    set(ENET_LIBRARIES "enet")
endif()

# Find system GLEW library or build it if missing
if (APPLE AND NOT IOS)
    find_library(GLEW_LIBRARY NAMES glew libglew libGLEW)
    find_path(GLEW_INCLUDEDIR NAMES GL/glew.h glew.h PATHS)
    if (NOT GLEW_LIBRARY OR NOT GLEW_INCLUDEDIR)
        add_subdirectory("${PROJECT_SOURCE_DIR}/lib/glew")
        include_directories("${PROJECT_SOURCE_DIR}/lib/glew/include")
        set(GLEW_LIBRARIES "glew")
    else()
        set(GLEW_LIBRARIES ${GLEW_LIBRARY})
        include_directories(${GLEW_INCLUDEDIR})
        MESSAGE(STATUS "Use system GLEW: ${GLEW_LIBRARIES}")
    endif()
elseif(NOT USE_GLES2 AND NOT SERVER_ONLY)
    add_definitions(-DGLEW_NO_GLU)
    if((UNIX AND NOT APPLE) AND USE_SYSTEM_GLEW)
        pkg_check_modules(GLEW glew>=2.1)
    endif()

    if(GLEW_FOUND)
        include_directories(${GLEW_INCLUDE_DIRS})
    else()
        # Fallback to built-in version silently
        add_subdirectory("${PROJECT_SOURCE_DIR}/lib/glew")
        include_directories("${PROJECT_SOURCE_DIR}/lib/glew/include")
        set(GLEW_LIBRARIES "glew")
    endif()
endif()

if (NOT SERVER_ONLY)
    # Add jpeg library
    find_package(JPEG REQUIRED)
    include_directories(${JPEG_INCLUDE_DIR})
endif()

if (BUILD_RECORDER)
    find_library(OPENGLRECORDER_LIBRARY NAMES openglrecorder libopenglrecorder PATHS "${PROJECT_SOURCE_DIR}/${DEPENDENCIES}/lib")
    find_path(OPENGLRECORDER_INCLUDEDIR NAMES openglrecorder.h PATHS "${PROJECT_SOURCE_DIR}/${DEPENDENCIES}/include")
    if (NOT OPENGLRECORDER_LIBRARY OR NOT OPENGLRECORDER_INCLUDEDIR)
        if(PROJECT_VERSION STREQUAL "git")
            message(WARNING "libopenglrecorder not found, disabling in-game recorder. "
                "To use recorder, install libopenglrecorder.")
            set(OPENGLRECORDER_LIBRARY CACHE INTERNAL "")
            set(OPENGLRECORDER_INCLUDEDIR CACHE INTERNAL "")
            set(BUILD_RECORDER OFF)
        else()
            message(FATAL_ERROR "libopenglrecorder not found. "
            "Either install libopenglrecorder or disable in-game recorder with -DBUILD_RECORDER=0")
        endif()
    else()
        include_directories(${OPENGLRECORDER_INCLUDEDIR})
        mark_as_advanced(OPENGLRECORDER_LIBRARY OPENGLRECORDER_INCLUDEDIR)
        add_definitions(-DENABLE_RECORDER)
    endif()
endif()

if(NOT SERVER_ONLY)
    add_subdirectory("${PROJECT_SOURCE_DIR}/lib/graphics_utils")
    include_directories("${PROJECT_SOURCE_DIR}/lib/graphics_utils")
endif()

# Libmcpp
find_library(MCPP_LIBRARY NAMES mcpp libmcpp)
find_path(MCPP_INCLUDEDIR NAMES mcpp_lib.h PATHS)
if (NOT MCPP_LIBRARY OR NOT MCPP_INCLUDEDIR)
    add_subdirectory("${PROJECT_SOURCE_DIR}/lib/mcpp")
    include_directories("${PROJECT_SOURCE_DIR}/lib/mcpp")
    SET(MCPP_LIBRARY mcpp)
    message(STATUS "System libmcpp not found, use the bundled one.")
else()
    include_directories("${MCPP_INCLUDEDIR}")
    MESSAGE(STATUS "Use system libmcpp: ${MCPP_LIBRARY}")
endif()

if(NOT SERVER_ONLY)
    if(USE_SYSTEM_SQUISH)
        find_library(SQUISH_LIBRARY NAMES squish libsquish)
        find_path(SQUISH_INCLUDEDIR NAMES squish.h PATHS)
    endif()
    if (NOT SQUISH_LIBRARY OR NOT SQUISH_INCLUDEDIR)
        add_subdirectory("${PROJECT_SOURCE_DIR}/lib/libsquish")
        include_directories("${PROJECT_SOURCE_DIR}/lib/libsquish")
        SET(SQUISH_LIBRARY squish)
    else()
        include_directories("${SQUISH_INCLUDEDIR}")
        MESSAGE(STATUS "Use system libsquish: ${SQUISH_LIBRARY}")
    endif()
endif()

# Build the irrlicht library
add_subdirectory("${PROJECT_SOURCE_DIR}/lib/irrlicht")
include_directories("${PROJECT_SOURCE_DIR}/lib/irrlicht/include")

# Build the Wiiuse library
# Note: wiiuse MUST be declared after irrlicht, since otherwise
# (at least on VS) irrlicht will find wiiuse io.h file because
# of the added include directory.
if(USE_WIIUSE)
    # Find system WiiUse library or build it if missing
    if((UNIX AND NOT APPLE) AND USE_SYSTEM_WIIUSE)
        find_package(WiiUse)
    endif()

    if(WIIUSE_FOUND)
        include_directories(${WIIUSE_INCLUDE_DIR})
    else()
        # Fallback to built-in version
        if(WIIUSE_BUILD)
            add_subdirectory("${PROJECT_SOURCE_DIR}/lib/wiiuse")
        endif()
        include_directories("${PROJECT_SOURCE_DIR}/lib/wiiuse/src")
        set(WIIUSE_LIBRARIES "wiiuse" "bluetooth")
    endif()
endif()

# Set include paths
include_directories(${STK_SOURCE_DIR})

if(APPLE AND NOT IOS)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -arch x86_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -arch x86_64 -F/Library/Frameworks")
elseif(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")   # Enable multi-processor compilation (faster)
endif()


# Build the angelscript library if not in system
if(USE_SYSTEM_ANGELSCRIPT)
    find_package(Angelscript)
    if(ANGELSCRIPT_FOUND)
        include_directories(${Angelscript_INCLUDE_DIRS})
    else()
        message(FATAL_ERROR "Angelscript not found. "
            "Either install angelscript or use built-in version using "
            "-DUSE_SYSTEM_ANGELSCRIPT=0")
    endif()
else()
    add_subdirectory("${PROJECT_SOURCE_DIR}/lib/angelscript/projects/cmake")
    include_directories("${PROJECT_SOURCE_DIR}/lib/angelscript/include")
    set(Angelscript_LIBRARIES angelscript)
endif()

if(NOT SERVER_ONLY)
    # OpenAL
    find_package(OpenAL REQUIRED)
    include_directories(${OPENAL_INCLUDE_DIR})

    # OggVorbis
    find_package(OggVorbis REQUIRED)
    include_directories(${OGGVORBIS_INCLUDE_DIRS})

    add_definitions(-DENABLE_SOUND)
endif()

# Text handling in STK (We use freetype, harfbuzz, fribidi and libraqm for i18n text handling)
if (NOT SERVER_ONLY)
    # Freetype

=== lib/bullet/CMakeLists.txt ===
# CMakeLists.txt for Bullet in STK

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/)

if(APPLE AND NOT IOS)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -arch x86_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -arch x86_64 -F/Library/Frameworks")
endif()

# libbulletmath
add_library(bulletmath STATIC
	src/LinearMath/btAabbUtil2.h           src/LinearMath/btMotionState.h
	src/LinearMath/btAlignedAllocator.cpp  src/LinearMath/btPoolAllocator.h
	src/LinearMath/btAlignedAllocator.h    src/LinearMath/btQuadWord.h
	src/LinearMath/btAlignedObjectArray.h  src/LinearMath/btQuaternion.h
	src/LinearMath/btConvexHull.cpp        src/LinearMath/btQuickprof.cpp
	src/LinearMath/btConvexHull.h          src/LinearMath/btQuickprof.h
	src/LinearMath/btConvexHullComputer.h  src/LinearMath/btConvexHullComputer.cpp
	src/LinearMath/btDefaultMotionState.h  src/LinearMath/btRandom.h
	src/LinearMath/btGeometryUtil.cpp      src/LinearMath/btScalar.h
	src/LinearMath/btGeometryUtil.h        src/LinearMath/btSerializer.cpp
        src/LinearMath/btGrahamScan2dConvexHull.h
	src/LinearMath/btHashMap.h             src/LinearMath/btSerializer.h
	src/LinearMath/btIDebugDraw.h          src/LinearMath/btStackAlloc.h
	src/LinearMath/btList.h                src/LinearMath/btTransform.h
	src/LinearMath/btMatrix3x3.h           src/LinearMath/btTransformUtil.h
	src/LinearMath/btMinMax.h              src/LinearMath/btVector3.h
	)

# TODO: original comment:
# Certain g++ versions causes stk to crash if btVoronoiSimplexSolver.cpp is
# compiled with optimisations. Since it's rather difficult to specify certain
# flags for one file only with auto-tools (you can only specify flags per
# library, so you have to put this one file into a separate library) we compile
# the whole libbulletcollision with the modified flags - i.e. by adding 
# -fno-elide-constructors to the flags. The overall performance impact is
# quite low anyway.

# libbulletcollision
add_library(bulletcollision STATIC
	src/BulletCollision/BroadphaseCollision/btAxisSweep3.cpp
	src/BulletCollision/BroadphaseCollision/btAxisSweep3.h
	src/BulletCollision/BroadphaseCollision/btBroadphaseInterface.h
	src/BulletCollision/BroadphaseCollision/btBroadphaseProxy.cpp
	src/BulletCollision/BroadphaseCollision/btBroadphaseProxy.h
	src/BulletCollision/BroadphaseCollision/btCollisionAlgorithm.cpp
	src/BulletCollision/BroadphaseCollision/btCollisionAlgorithm.h
	src/BulletCollision/BroadphaseCollision/btDbvtBroadphase.cpp
	src/BulletCollision/BroadphaseCollision/btDbvtBroadphase.h
	src/BulletCollision/BroadphaseCollision/btDbvt.cpp
	src/BulletCollision/BroadphaseCollision/btDbvt.h
	src/BulletCollision/BroadphaseCollision/btDispatcher.cpp
	src/BulletCollision/BroadphaseCollision/btDispatcher.h
	src/BulletCollision/BroadphaseCollision/btMultiSapBroadphase.cpp
	src/BulletCollision/BroadphaseCollision/btMultiSapBroadphase.h
	src/BulletCollision/BroadphaseCollision/btOverlappingPairCache.cpp
	src/BulletCollision/BroadphaseCollision/btOverlappingPairCache.h
	src/BulletCollision/BroadphaseCollision/btOverlappingPairCallback.h
	src/BulletCollision/BroadphaseCollision/btQuantizedBvh.cpp
	src/BulletCollision/BroadphaseCollision/btQuantizedBvh.h
	src/BulletCollision/BroadphaseCollision/btSimpleBroadphase.cpp
	src/BulletCollision/BroadphaseCollision/btSimpleBroadphase.h
	src/BulletCollision/CollisionDispatch/btActivatingCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btActivatingCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btBox2dBox2dCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btBox2dBox2dCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btBoxBoxCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btBoxBoxCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btBoxBoxDetector.cpp
	src/BulletCollision/CollisionDispatch/btBoxBoxDetector.h
	src/BulletCollision/CollisionDispatch/btCollisionConfiguration.h
	src/BulletCollision/CollisionDispatch/btCollisionCreateFunc.h
	src/BulletCollision/CollisionDispatch/btCollisionDispatcher.cpp
	src/BulletCollision/CollisionDispatch/btCollisionDispatcher.h
	src/BulletCollision/CollisionDispatch/btCollisionObject.cpp
	src/BulletCollision/CollisionDispatch/btCollisionObject.h
	src/BulletCollision/CollisionDispatch/btCollisionWorld.cpp
	src/BulletCollision/CollisionDispatch/btCollisionWorld.h
	src/BulletCollision/CollisionDispatch/btCompoundCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btCompoundCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btConvex2dConvex2dAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btConvex2dConvex2dAlgorithm.h
	src/BulletCollision/CollisionDispatch/btConvexConcaveCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btConvexConcaveCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btConvexConvexAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btConvexConvexAlgorithm.h
	src/BulletCollision/CollisionDispatch/btConvexPlaneCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btConvexPlaneCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btDefaultCollisionConfiguration.cpp
	src/BulletCollision/CollisionDispatch/btDefaultCollisionConfiguration.h
	src/BulletCollision/CollisionDispatch/btEmptyCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btEmptyCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btGhostObject.cpp
	src/BulletCollision/CollisionDispatch/btGhostObject.h
	src/BulletCollision/CollisionDispatch/btInternalEdgeUtility.cpp
	src/BulletCollision/CollisionDispatch/btInternalEdgeUtility.h
	src/BulletCollision/CollisionDispatch/btManifoldResult.cpp
	src/BulletCollision/CollisionDispatch/btManifoldResult.h
	src/BulletCollision/CollisionDispatch/btSimulationIslandManager.cpp
	src/BulletCollision/CollisionDispatch/btSimulationIslandManager.h
	src/BulletCollision/CollisionDispatch/btSphereBoxCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btSphereBoxCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btSphereSphereCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btSphereSphereCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btSphereTriangleCollisionAlgorithm.cpp
	src/BulletCollision/CollisionDispatch/btSphereTriangleCollisionAlgorithm.h
	src/BulletCollision/CollisionDispatch/btUnionFind.cpp
	src/BulletCollision/CollisionDispatch/btUnionFind.h
	src/BulletCollision/CollisionDispatch/SphereTriangleDetector.cpp
	src/BulletCollision/CollisionDispatch/SphereTriangleDetector.h
	src/BulletCollision/CollisionShapes/btBox2dShape.cpp
	src/BulletCollision/CollisionShapes/btBox2dShape.h
	src/BulletCollision/CollisionShapes/btBoxShape.cpp
	src/BulletCollision/CollisionShapes/btBoxShape.h
	src/BulletCollision/CollisionShapes/btBvhTriangleMeshShape.cpp
	src/BulletCollision/CollisionShapes/btBvhTriangleMeshShape.h
	src/BulletCollision/CollisionShapes/btCapsuleShape.cpp
	src/BulletCollision/CollisionShapes/btCapsuleShape.h
	src/BulletCollision/CollisionShapes/btCollisionMargin.h
	src/BulletCollision/CollisionShapes/btCollisionShape.cpp
	src/BulletCollision/CollisionShapes/btCollisionShape.h
	src/BulletCollision/CollisionShapes/btCompoundShape.cpp
	src/BulletCollision/CollisionShapes/btCompoundShape.h
	src/BulletCollision/CollisionShapes/btConcaveShape.cpp
	src/BulletCollision/CollisionShapes/btConcaveShape.h
	src/BulletCollision/CollisionShapes/btConeShape.cpp
	src/BulletCollision/CollisionShapes/btConeShape.h
	src/BulletCollision/CollisionShapes/btConvex2dShape.cpp
	src/BulletCollision/CollisionShapes/btConvex2dShape.h
	src/BulletCollision/CollisionShapes/btConvexHullShape.cpp
	src/BulletCollision/CollisionShapes/btConvexHullShape.h
	src/BulletCollision/CollisionShapes/btConvexInternalShape.cpp
	src/BulletCollision/CollisionShapes/btConvexInternalShape.h
	src/BulletCollision/CollisionShapes/btConvexPointCloudShape.cpp
	src/BulletCollision/CollisionShapes/btConvexPointCloudShape.h
	src/BulletCollision/CollisionShapes/btConvexPolyhedron.cpp
	src/BulletCollision/CollisionShapes/btConvexPolyhedron.h
	src/BulletCollision/CollisionShapes/btConvexShape.cpp
	src/BulletCollision/CollisionShapes/btConvexShape.h
	src/BulletCollision/CollisionShapes/btConvexTriangleMeshShape.cpp
	src/BulletCollision/CollisionShapes/btConvexTriangleMeshShape.h
	src/BulletCollision/CollisionShapes/btCylinderShape.cpp
	src/BulletCollision/CollisionShapes/btCylinderShape.h
	src/BulletCollision/CollisionShapes/btEmptyShape.cpp
	src/BulletCollision/CollisionShapes/btEmptyShape.h
	src/BulletCollision/CollisionShapes/btHeightfieldTerrainShape.cpp
	src/BulletCollision/CollisionShapes/btHeightfieldTerrainShape.h
	src/BulletCollision/CollisionShapes/btMaterial.h
	src/BulletCollision/CollisionShapes/btMinkowskiSumShape.cpp
	src/BulletCollision/CollisionShapes/btMinkowskiSumShape.h
	src/BulletCollision/CollisionShapes/btMultimaterialTriangleMeshShape.cpp
	src/BulletCollision/CollisionShapes/btMultimaterialTriangleMeshShape.h
	src/BulletCollision/CollisionShapes/btMultiSphereShape.cpp
	src/BulletCollision/CollisionShapes/btMultiSphereShape.h
	src/BulletCollision/CollisionShapes/btOptimizedBvh.cpp
	src/BulletCollision/CollisionShapes/btOptimizedBvh.h
	src/BulletCollision/CollisionShapes/btPolyhedralConvexShape.cpp
	src/BulletCollision/CollisionShapes/btPolyhedralConvexShape.h
	src/BulletCollision/CollisionShapes/btScaledBvhTriangleMeshShape.cpp
	src/BulletCollision/CollisionShapes/btScaledBvhTriangleMeshShape.h
	src/BulletCollision/CollisionShapes/btShapeHull.cpp
	src/BulletCollision/CollisionShapes/btShapeHull.h
	src/BulletCollision/CollisionShapes/btSphereShape.cpp
	src/BulletCollision/CollisionShapes/btSphereShape.h
	src/BulletCollision/CollisionShapes/btStaticPlaneShape.cpp
	src/BulletCollision/CollisionShapes/btStaticPlaneShape.h
	src/BulletCollision/CollisionShapes/btStridingMeshInterface.cpp
	src/BulletCollision/CollisionShapes/btStridingMeshInterface.h
	src/BulletCollision/CollisionShapes/btTetrahedronShape.cpp
	src/BulletCollision/CollisionShapes/btTetrahedronShape.h
	src/BulletCollision/CollisionShapes/btTriangleBuffer.cpp
	src/BulletCollision/CollisionShapes/btTriangleBuffer.h
	src/BulletCollision/CollisionShapes/btTriangleCallback.cpp
	src/BulletCollision/CollisionShapes/btTriangleCallback.h
	src/BulletCollision/CollisionShapes/btTriangleIndexVertexArray.cpp
	src/BulletCollision/CollisionShapes/btTriangleIndexVertexArray.h
	src/BulletCollision/CollisionShapes/btTriangleIndexVertexMaterialArray.cpp
	src/BulletCollision/CollisionShapes/btTriangleIndexVertexMaterialArray.h
	src/BulletCollision/CollisionShapes/btTriangleInfoMap.h
	src/BulletCollision/CollisionShapes/btTriangleMesh.cpp
	src/BulletCollision/CollisionShapes/btTriangleMesh.h
	src/BulletCollision/CollisionShapes/btTriangleMeshShape.cpp
	src/BulletCollision/CollisionShapes/btTriangleMeshShape.h
	src/BulletCollision/CollisionShapes/btTriangleShape.h
	src/BulletCollision/CollisionShapes/btUniformScalingShape.cpp
	src/BulletCollision/CollisionShapes/btUniformScalingShape.h
	src/BulletCollision/Gimpact/btBoxCollision.h
	src/BulletCollision/Gimpact/btClipPolygon.h
	src/BulletCollision/Gimpact/btContactProcessing.cpp
	src/BulletCollision/Gimpact/btContactProcessing.h
	src/BulletCollision/Gimpact/btGenericPoolAllocator.cpp
	src/BulletCollision/Gimpact/btGenericPoolAllocator.h
	src/BulletCollision/Gimpact/btGeometryOperations.h
	src/BulletCollision/Gimpact/btGImpactBvh.cpp
	src/BulletCollision/Gimpact/btGImpactBvh.h
	src/BulletCollision/Gimpact/btGImpactCollisionAlgorithm.cpp
	src/BulletCollision/Gimpact/btGImpactCollisionAlgorithm.h
	src/BulletCollision/Gimpact/btGImpactMassUtil.h
	src/BulletCollision/Gimpact/btGImpactQuantizedBvh.cpp
	src/BulletCollision/Gimpact/btGImpactQuantizedBvh.h
	src/BulletCollision/Gimpact/btGImpactShape.cpp
	src/BulletCollision/Gimpact/btGImpactShape.h
	src/BulletCollision/Gimpact/btQuantization.h
	src/BulletCollision/Gimpact/btTriangleShapeEx.cpp

=== lib/enet/CMakeLists.txt ===
# CMakeLists.txt - enet

include_directories("include")

if(APPLE AND NOT IOS)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -arch x86_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -arch x86_64 -F/Library/Frameworks")
endif()

add_definitions(-DHAS_SOCKLEN_T)

add_library(enet STATIC
	callbacks.c
	compress.c
	host.c
	list.c
	packet.c
	peer.c
	protocol.c
	unix.c
	win32.c
)

if(WIN32)
  target_link_libraries(enet wsock32 ws2_32 winmm)
endif()

=== lib/graphics_utils/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
if (UNIX OR MINGW)
    add_definitions(-O3)
endif()
add_library(graphics_utils STATIC
    mipmap/cpusimd.c
    mipmap/imgresize.c
)

=== lib/irrlicht/CMakeLists.txt ===
# CMakeLists.txt for Irrlicht in STK
if(NOT SERVER_ONLY)
    find_package(PNG REQUIRED)
    find_package(JPEG REQUIRED)
    find_package(ZLIB REQUIRED)
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include/"
                        "${JPEG_INCLUDE_DIR}"
                        "${PNG_INCLUDE_DIRS}"
                        "${ZLIB_INCLUDE_DIR}"
                        "${CMAKE_CURRENT_SOURCE_DIR}/../../src")

    if(MSVC)
        include_directories("${CMAKE_CURRENT_BINARY_DIR}/../zlib/") # For zconf.h on WIN32
    endif()

    if(MSVC)
        include_directories("${CMAKE_CURRENT_BINARY_DIR}/../libpng/")
    endif()

    if(NOT USE_GLES2)
        find_package(OpenGL REQUIRED)
        include_directories(${OPENGL_INCLUDE_DIR})
    endif()
        
    if(UNIX AND NOT APPLE)
        find_package(X11 REQUIRED)
        include_directories(${X11_INCLUDE_DIR})
        
        if(NOT X11_FOUND)
            message(FATAL_ERROR "X11 not found.")
        endif()
        
        if(NOT X11_Xrandr_FOUND)
            message(FATAL_ERROR "XRANDR not found.")
        endif()
    endif()

    if(NOT APPLE AND (USE_GLES2 OR ENABLE_WAYLAND_DEVICE))
        find_package(EGL)
        
        if(EGL_FOUND)
            include_directories(${EGL_INCLUDE_DIR})
        else()
            if(USE_GLES2 AND NOT APPLE)
                message(FATAL_ERROR "EGL not found.")
            elseif(ENABLE_WAYLAND_DEVICE)
                message(WARNING "EGL not found. Disable wayland support.")
                set(ENABLE_WAYLAND_DEVICE OFF)
            endif()
        endif()
    endif()

    if(ENABLE_WAYLAND_DEVICE)
        find_package(Wayland)
        
        if(WAYLAND_FOUND AND NOT (WAYLAND_VERSION VERSION_LESS "1.14"))
            include_directories(${WAYLAND_INCLUDE_DIR})
            add_definitions(-D_IRR_COMPILE_WITH_WAYLAND_DEVICE_)
        else()
            message(WARNING "Wayland not found. Disable wayland support.")
            set(ENABLE_WAYLAND_DEVICE OFF)
        endif()        
    endif()
else()
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include/"
                        "${CMAKE_CURRENT_SOURCE_DIR}/../../src")
    find_package(ZLIB REQUIRED)
    include_directories("${ZLIB_INCLUDE_DIR}")
    add_definitions(-DNO_IRR_COMPILE_WITH_LIBPNG_)
    add_definitions(-DNO_IRR_COMPILE_WITH_LIBJPEG_)
    add_definitions(-DNO_IRR_COMPILE_WITH_BMP_LOADER_)
    add_definitions(-DNO_IRR_COMPILE_WITH_PNG_LOADER_)
    add_definitions(-DNO_IRR_COMPILE_WITH_JPG_LOADER_)
    add_definitions(-DNO_IRR_COMPILE_WITH_BMP_WRITER_)
    add_definitions(-DNO_IRR_COMPILE_WITH_PNG_WRITER_)
    add_definitions(-DNO_IRR_COMPILE_WITH_JPG_WRITER_)
    add_definitions(-DNO_IRR_COMPILE_WITH_OPENGL_)
    add_definitions(-DNO_IRR_COMPILE_WITH_X11_)
    add_definitions(-DNO_IRR_COMPILE_WITH_WAYLAND_DEVICE_)
endif()

if(APPLE AND NOT IOS)
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/source/Irrlicht/MacOSX" "${CMAKE_CURRENT_SOURCE_DIR}/source/Irrlicht")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -arch x86_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -arch x86_64 -F/Library/Frameworks")
endif()

add_definitions(-DNDEBUG=1 -DIRRLICHT_EXPORTS=1 -DPNG_THREAD_UNSAFE_OK -DPNG_NO_MMX_CODE -DPNG_NO_MNG_FEATURES)

if(UNIX OR MINGW)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++0x")
endif()

if(WIN32)
    add_definitions(-D_IRR_STATIC_LIB_)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS) # Shut up about unsafe stuff
else()
    set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS} -Wall -pipe -O3 -fstrict-aliasing")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pipe -O3 -fstrict-aliasing")
    if(CMAKE_COMPILER_IS_GNUCC)
        set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS} -fexpensive-optimizations")
    endif()
    if(CMAKE_COMPILER_IS_GNUCXX)
        set(CMAKE_CXX_FLAGS   "${CMAKE_CXX_FLAGS} -fexpensive-optimizations")
    endif()
endif()

if(USE_GLES2)
    add_definitions(-D_IRR_COMPILE_WITH_OGLES2_ -DNO_IRR_COMPILE_WITH_OPENGL_)
endif()

if(CYGWIN)
    add_definitions(-DNO_IRR_COMPILE_WITH_JOYSTICK_EVENTS_)
endif()


set(IRRLICHT_SOURCES
source/Irrlicht/CAnimatedMeshSceneNode.cpp
source/Irrlicht/CAttributes.cpp
source/Irrlicht/CBillboardSceneNode.cpp
source/Irrlicht/CBoneSceneNode.cpp
source/Irrlicht/CCameraSceneNode.cpp
source/Irrlicht/CContextEGL.cpp
source/Irrlicht/CColorConverter.cpp
source/Irrlicht/CCubeSceneNode.cpp
source/Irrlicht/CDefaultGUIElementFactory.cpp
source/Irrlicht/CDefaultSceneNodeAnimatorFactory.cpp
source/Irrlicht/CDefaultSceneNodeFactory.cpp
source/Irrlicht/CDummyTransformationSceneNode.cpp
source/Irrlicht/CEmptySceneNode.cpp
source/Irrlicht/CFileList.cpp
source/Irrlicht/CFileSystem.cpp
source/Irrlicht/CFPSCounter.cpp
source/Irrlicht/CGeometryCreator.cpp
source/Irrlicht/CGUIButton.cpp
source/Irrlicht/CGUICheckBox.cpp
source/Irrlicht/CGUIColorSelectDialog.cpp
source/Irrlicht/CGUIComboBox.cpp
source/Irrlicht/CGUIContextMenu.cpp
source/Irrlicht/CGUIEditBox.cpp
source/Irrlicht/CGUIEnvironment.cpp
source/Irrlicht/CGUIFileOpenDialog.cpp
source/Irrlicht/CGUIFont.cpp
source/Irrlicht/CGUIImage.cpp
source/Irrlicht/CGUIImageList.cpp
source/Irrlicht/CGUIInOutFader.cpp
source/Irrlicht/CGUIListBox.cpp
source/Irrlicht/CGUIMenu.cpp
source/Irrlicht/CGUIMeshViewer.cpp
source/Irrlicht/CGUIMessageBox.cpp
source/Irrlicht/CGUIModalScreen.cpp
source/Irrlicht/CGUIScrollBar.cpp
source/Irrlicht/CGUISkin.cpp
source/Irrlicht/CGUISpinBox.cpp
source/Irrlicht/CGUISpriteBank.cpp
source/Irrlicht/CGUIStaticText.cpp
source/Irrlicht/CGUITabControl.cpp
source/Irrlicht/CGUITable.cpp
source/Irrlicht/CGUIToolBar.cpp
source/Irrlicht/CGUITreeView.cpp
source/Irrlicht/CGUIWindow.cpp
source/Irrlicht/CImage.cpp
source/Irrlicht/CImageLoaderBMP.cpp
source/Irrlicht/CImageLoaderJPG.cpp
source/Irrlicht/CImageLoaderPNG.cpp
source/Irrlicht/CImageWriterBMP.cpp
source/Irrlicht/CImageWriterJPG.cpp
source/Irrlicht/CImageWriterPNG.cpp
source/Irrlicht/CIrrDeviceAndroid.cpp
source/Irrlicht/CIrrDeviceLinux.cpp
source/Irrlicht/CIrrDeviceSDL.cpp
source/Irrlicht/CIrrDeviceStub.cpp
source/Irrlicht/CIrrDeviceWayland.cpp
source/Irrlicht/CIrrDeviceWin32.cpp
source/Irrlicht/CLightSceneNode.cpp
source/Irrlicht/CLimitReadFile.cpp
source/Irrlicht/CLogger.cpp
source/Irrlicht/CMemoryFile.cpp
source/Irrlicht/CMeshCache.cpp
source/Irrlicht/CMeshManipulator.cpp
source/Irrlicht/CMeshSceneNode.cpp
source/Irrlicht/CMetaTriangleSelector.cpp
source/Irrlicht/CMountPointReader.cpp
source/Irrlicht/CNullDriver.cpp
source/Irrlicht/COctreeSceneNode.cpp
source/Irrlicht/COctreeTriangleSelector.cpp
source/Irrlicht/COGLES2Driver.cpp
source/Irrlicht/COGLES2ExtensionHandler.cpp
source/Irrlicht/COGLES2FixedPipelineRenderer.cpp
source/Irrlicht/COGLES2MaterialRenderer.cpp
source/Irrlicht/COGLES2NormalMapRenderer.cpp
source/Irrlicht/COGLES2ParallaxMapRenderer.cpp
source/Irrlicht/COGLES2Renderer2D.cpp
source/Irrlicht/COGLES2Texture.cpp
source/Irrlicht/COpenGLDriver.cpp
source/Irrlicht/COpenGLExtensionHandler.cpp
source/Irrlicht/COpenGLParallaxMapRenderer.cpp
source/Irrlicht/COpenGLShaderMaterialRenderer.cpp
source/Irrlicht/COpenGLSLMaterialRenderer.cpp
source/Irrlicht/COpenGLTexture.cpp
source/Irrlicht/COSOperator.cpp
source/Irrlicht/CParticleAnimatedMeshSceneNodeEmitter.cpp
source/Irrlicht/CParticleAttractionAffector.cpp
source/Irrlicht/CParticleBoxEmitter.cpp
source/Irrlicht/CParticleCylinderEmitter.cpp
source/Irrlicht/CParticleFadeOutAffector.cpp
source/Irrlicht/CParticleGravityAffector.cpp
source/Irrlicht/CParticleMeshEmitter.cpp
source/Irrlicht/CParticlePointEmitter.cpp
source/Irrlicht/CParticleRingEmitter.cpp
source/Irrlicht/CParticleRotationAffector.cpp
source/Irrlicht/CParticleScaleAffector.cpp
source/Irrlicht/CParticleSphereEmitter.cpp
source/Irrlicht/CParticleSystemSceneNode.cpp
source/Irrlicht/CReadFile.cpp
source/Irrlicht/CSceneCollisionManager.cpp
source/Irrlicht/CSceneManager.cpp
source/Irrlicht/CSceneNodeAnimatorCameraFPS.cpp
source/Irrlicht/CSceneNodeAnimatorCameraMaya.cpp
source/Irrlicht/CSceneNodeAnimatorCollisionResponse.cpp
source/Irrlicht/CSceneNodeAnimatorDelete.cpp
source/Irrlicht/CSceneNodeAnimatorFlyCircle.cpp
source/Irrlicht/CSceneNodeAnimatorFlyStraight.cpp
source/Irrlicht/CSceneNodeAnimatorFollowSpline.cpp
source/Irrlicht/CSceneNodeAnimatorRotation.cpp
source/Irrlicht/CSceneNodeAnimatorTexture.cpp
source/Irrlicht/CSkinnedMesh.cpp
source/Irrlicht/CSkyBoxSceneNode.cpp
source/Irrlicht/CSkyDomeSceneNode.cpp
source/Irrlicht/CSphereSceneNode.cpp
source/Irrlicht/CTarReader.cpp
source/Irrlicht/CTerrainSceneNode.cpp
source/Irrlicht/CTerrainTriangleSelector.cpp
source/Irrlicht/CTextSceneNode.cpp
source/Irrlicht/CTriangleBBSelector.cpp
source/Irrlicht/CTriangleSelector.cpp
source/Irrlicht/CVideoModeList.cpp
source/Irrlicht/CWaterSurfaceSceneNode.cpp
source/Irrlicht/CWriteFile.cpp
source/Irrlicht/CXMLReader.cpp
source/Irrlicht/CXMLWriter.cpp
source/Irrlicht/CZBuffer.cpp
source/Irrlicht/CZipReader.cpp
source/Irrlicht/Irrlicht.cpp
source/Irrlicht/irrXML.cpp
source/Irrlicht/os.cpp
source/Irrlicht/COpenGLNormalMapRenderer.cpp
source/Irrlicht/CAnimatedMeshSceneNode.h
source/Irrlicht/CAttributeImpl.h
source/Irrlicht/CAttributes.h
source/Irrlicht/CBillboardSceneNode.h
source/Irrlicht/CBlit.h
source/Irrlicht/CBoneSceneNode.h
source/Irrlicht/CCameraSceneNode.h
source/Irrlicht/CContextEGL.h
source/Irrlicht/CColorConverter.h
source/Irrlicht/CCubeSceneNode.h
source/Irrlicht/CDefaultGUIElementFactory.h
source/Irrlicht/CDefaultSceneNodeAnimatorFactory.h
source/Irrlicht/CDefaultSceneNodeFactory.h
source/Irrlicht/CDummyTransformationSceneNode.h
source/Irrlicht/CEmptySceneNode.h
source/Irrlicht/CFileList.h
source/Irrlicht/CFileSystem.h
source/Irrlicht/CFPSCounter.h
source/Irrlicht/CGeometryCreator.h
source/Irrlicht/CGUIButton.h
source/Irrlicht/CGUICheckBox.h
source/Irrlicht/CGUIColorSelectDialog.h
source/Irrlicht/CGUIComboBox.h
source/Irrlicht/CGUIContextMenu.h
source/Irrlicht/CGUIEditBox.h
source/Irrlicht/CGUIEnvironment.h
source/Irrlicht/CGUIFileOpenDialog.h
source/Irrlicht/CGUIFont.h
source/Irrlicht/CGUIImage.h
source/Irrlicht/CGUIImageList.h
source/Irrlicht/CGUIInOutFader.h
source/Irrlicht/CGUIListBox.h
source/Irrlicht/CGUIMenu.h
source/Irrlicht/CGUIMeshViewer.h
source/Irrlicht/CGUIMessageBox.h
source/Irrlicht/CGUIModalScreen.h
source/Irrlicht/CGUIScrollBar.h
source/Irrlicht/CGUISkin.h
source/Irrlicht/CGUISpinBox.h
source/Irrlicht/CGUISpriteBank.h
source/Irrlicht/CGUIStaticText.h
source/Irrlicht/CGUITabControl.h
source/Irrlicht/CGUITable.h
source/Irrlicht/CGUIToolBar.h
source/Irrlicht/CGUITreeView.h
source/Irrlicht/CGUIWindow.h
source/Irrlicht/CImage.h
source/Irrlicht/CImageLoaderBMP.h
source/Irrlicht/CImageLoaderJPG.h
source/Irrlicht/CImageLoaderPNG.h
source/Irrlicht/CImageWriterBMP.h
source/Irrlicht/CImageWriterJPG.h
source/Irrlicht/CImageWriterPNG.h
source/Irrlicht/CIrrDeviceAndroid.h
source/Irrlicht/CIrrDeviceLinux.h
source/Irrlicht/CIrrDeviceSDL.h
source/Irrlicht/CIrrDeviceStub.h
source/Irrlicht/CIrrDeviceWayland.h
source/Irrlicht/CIrrDeviceWin32.h
source/Irrlicht/CLightSceneNode.h
source/Irrlicht/CLimitReadFile.h
source/Irrlicht/CLogger.h
source/Irrlicht/CMemoryFile.h
source/Irrlicht/CMeshCache.h
source/Irrlicht/CMeshManipulator.h
source/Irrlicht/CMeshSceneNode.h
source/Irrlicht/CMetaTriangleSelector.h
source/Irrlicht/CMountPointReader.h
source/Irrlicht/CNullDriver.h
source/Irrlicht/COctreeSceneNode.h
source/Irrlicht/COctreeTriangleSelector.h
source/Irrlicht/COGLES2Driver.h
source/Irrlicht/COGLES2ExtensionHandler.h
source/Irrlicht/COGLES2FixedPipelineRenderer.h
source/Irrlicht/COGLES2MaterialRenderer.h
source/Irrlicht/COGLES2NormalMapRenderer.h
source/Irrlicht/COGLES2ParallaxMapRenderer.h
source/Irrlicht/COGLES2Renderer2D.h
source/Irrlicht/COGLES2Texture.h
source/Irrlicht/COpenGLDriver.h
source/Irrlicht/COpenGLExtensionHandler.h
source/Irrlicht/COpenGLMaterialRenderer.h
source/Irrlicht/COpenGLParallaxMapRenderer.h
source/Irrlicht/COpenGLShaderMaterialRenderer.h
source/Irrlicht/COpenGLSLMaterialRenderer.h
source/Irrlicht/COpenGLTexture.h
source/Irrlicht/COSOperator.h

=== lib/angelscript/projects/cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)
cmake_policy(SET CMP0003 NEW)

if(NOT (CMAKE_MAJOR_VERSION VERSION_LESS 3))
  cmake_policy(SET CMP0048 OLD)
endif()

project(angelscript)

option(BUILD_SHARED_LIBS "Build shared library" OFF)

if(APPLE)
    option(BUILD_FRAMEWORK "Build Framework bundle for OSX" OFF)
endif()

file(READ ../../include/angelscript.h ANGELSCRIPT_H)
string(REGEX MATCH "#define ANGELSCRIPT_VERSION_STRING \"([0-9]*).([0-9]*).([0-9]*)" ANGELSCRIPT_VERSION_REGEX ${ANGELSCRIPT_H})
set(ANGELSCRIPT_VERSION_MAJOR ${CMAKE_MATCH_1})
set(ANGELSCRIPT_VERSION_MINOR ${CMAKE_MATCH_2})
set(ANGELSCRIPT_VERSION_PATCH ${CMAKE_MATCH_3})
set(PROJECT_VERSION ${ANGELSCRIPT_VERSION_MAJOR}.${ANGELSCRIPT_VERSION_MINOR}.${ANGELSCRIPT_VERSION_PATCH})

message(STATUS "Configuring angelscript ${PROJECT_VERSION}")

find_package(Threads)

set(ANGELSCRIPT_HEADERS
    ../../include/angelscript.h
    ../../source/as_array.h
    ../../source/as_builder.h
    ../../source/as_bytecode.h
    ../../source/as_callfunc.h
    ../../source/as_compiler.h
    ../../source/as_config.h
    ../../source/as_configgroup.h
    ../../source/as_context.h
    ../../source/as_criticalsection.h
    ../../source/as_datatype.h
    ../../source/as_debug.h
    ../../source/as_generic.h
    ../../source/as_map.h
    ../../source/as_memory.h
    ../../source/as_module.h
    ../../source/as_objecttype.h
    ../../source/as_outputbuffer.h
    ../../source/as_parser.h
    ../../source/as_property.h
    ../../source/as_restore.h
    ../../source/as_scriptcode.h
    ../../source/as_scriptengine.h
    ../../source/as_scriptfunction.h
    ../../source/as_scriptnode.h
    ../../source/as_scriptobject.h
    ../../source/as_string.h
    ../../source/as_string_util.h
    ../../source/as_texts.h
    ../../source/as_thread.h
    ../../source/as_tokendef.h
    ../../source/as_tokenizer.h
    ../../source/as_typeinfo.h
    ../../source/as_variablescope.h
)

set(ANGELSCRIPT_SOURCE
    ../../source/as_atomic.cpp
    ../../source/as_builder.cpp
    ../../source/as_bytecode.cpp
    ../../source/as_callfunc.cpp
    ../../source/as_callfunc_mips.cpp
    ../../source/as_callfunc_x86.cpp
    ../../source/as_callfunc_x64_gcc.cpp
    ../../source/as_callfunc_x64_msvc.cpp
    ../../source/as_callfunc_x64_mingw.cpp
    ../../source/as_compiler.cpp
    ../../source/as_configgroup.cpp
    ../../source/as_context.cpp
    ../../source/as_datatype.cpp
    ../../source/as_gc.cpp
    ../../source/as_generic.cpp
    ../../source/as_globalproperty.cpp
    ../../source/as_memory.cpp
    ../../source/as_module.cpp
    ../../source/as_objecttype.cpp
    ../../source/as_outputbuffer.cpp
    ../../source/as_parser.cpp
    ../../source/as_restore.cpp
    ../../source/as_scriptcode.cpp
    ../../source/as_scriptengine.cpp
    ../../source/as_scriptfunction.cpp
    ../../source/as_scriptnode.cpp
    ../../source/as_scriptobject.cpp
    ../../source/as_string.cpp
    ../../source/as_string_util.cpp
    ../../source/as_thread.cpp
    ../../source/as_tokenizer.cpp
    ../../source/as_typeinfo.cpp
    ../../source/as_variablescope.cpp
)

if(MSVC AND CMAKE_CL_64)
    enable_language(ASM_MASM)
    if(CMAKE_ASM_MASM_COMPILER_WORKS)
        set(ANGELSCRIPT_SOURCE ${ANGELSCRIPT_SOURCE} ../../source/as_callfunc_x64_msvc_asm.asm)
    else()
        message(FATAL ERROR "MSVC x86_64 target requires a working assembler")
    endif()
endif()

if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "^arm")
    enable_language(ASM)
    if(CMAKE_ASM_COMPILER_WORKS)
        set(ANGELSCRIPT_SOURCE ${ANGELSCRIPT_SOURCE} ../../source/as_callfunc_arm.cpp ../../source/as_callfunc_arm_gcc.S)
        if (NOT IOS)
            set_property(SOURCE ../../source/as_callfunc_arm_gcc.S APPEND PROPERTY COMPILE_FLAGS " -Wa,-mimplicit-it=always")
        endif()
    else()
        message(FATAL ERROR "ARM target requires a working assembler")
    endif()
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../include)

if(MSVC)
    set(CMAKE_DEBUG_POSTFIX "d")
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)    
endif()

add_definitions(-DANGELSCRIPT_EXPORT -D_LIB)

# Fix x64 issues on Linux
if("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64" AND NOT APPLE)
    add_definitions(-fPIC)
endif()

if(NOT BUILD_FRAMEWORK)
    set(ANGELSCRIPT_LIBRARY_NAME angelscript)
else()
    set(ANGELSCRIPT_LIBRARY_NAME Angelscript) # OS X frameworks should have capitalized name
    set(BUILD_SHARED_LIBS TRUE)
endif()
set(ANGELSCRIPT_LIBRARY_NAME ${ANGELSCRIPT_LIBRARY_NAME} CACHE STRING "" FORCE)

add_library(${ANGELSCRIPT_LIBRARY_NAME} ${ANGELSCRIPT_SOURCE} ${ANGELSCRIPT_HEADERS})
# Don't override the default library output path to avoid conflicts when building for multiple target platforms
#set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/../../lib)
target_link_libraries(${ANGELSCRIPT_LIBRARY_NAME} ${CMAKE_THREAD_LIBS_INIT})

set_target_properties(${ANGELSCRIPT_LIBRARY_NAME} PROPERTIES VERSION ${PROJECT_VERSION})

if(BUILD_FRAMEWORK)
    set_target_properties(${ANGELSCRIPT_LIBRARY_NAME} PROPERTIES
        FRAMEWORK TRUE
        FRAMEWORK_VERSION ${PROJECT_VERSION}
        MACOSX_FRAMEWORK_IDENTIFIER com.angelcode.Angelscript
        MACOSX_FRAMEWORK_SHORT_VERSION_STRING ${PROJECT_VERSION}
        MACOSX_FRAMEWORK_BUNDLE_VERSION ${PROJECT_VERSION}
        XCODE_ATTRIBUTE_INSTALL_PATH "@rpath"
        PUBLIC_HEADER ../../include/angelscript.h
    )
endif()

if(MSVC)
    set_target_properties(${ANGELSCRIPT_LIBRARY_NAME} PROPERTIES COMPILE_FLAGS "/MP")
endif()

# Don't override the default runtime output path to avoid conflicts when building for multiple target platforms
#set(RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/../../bin)

=== lib/wiiuse/cmake/nested_targets/DCubed/d3ew_p/CMakeLists.txt ===
# - Build the DCubed wrapper library d3ew_p as a part of your solution.
#
# Original Author:
# 2009-2010 Ryan Pavlik <rpavlik@iastate.edu> <abiryan@ryand.net>
# http://academic.cleardefinition.com
# Iowa State University HCI Graduate Program/VRAC
#
# Copyright Iowa State University 2009-2010.
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file ../../LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)


set(SOURCES)
foreach(filename d3ew_p.rc
	p_dll.cpp
	p_dll.hxx
	p_dump.cpp
	p_frustrum.cpp
	p_gate.cpp
	p_gate.hxx
	p_lib.cpp
	p_modeller.cpp
	p_new.hxx
	p_rollmark.cpp
	p_utils.cpp
	p_utils.hxx
	res_defs.hxx)
	list(APPEND SOURCES "${DCUBED_WRAPPER_INCLUDE_DIR}/d3ew_p/${filename}")
endforeach()
add_library(dcubed_wrapper_d3ew_p_nested_target
	STATIC
	EXCLUDE_FROM_ALL
	${SOURCES})
target_link_libraries(dcubed_wrapper_d3ew_p_nested_target ${DCUBED_LIBRARIES} ${PARASOLID_LIBRARIES} "${DCUBED_WRAPPER_d3ew_scene_LIBRARY}")

set_property(TARGET
	dcubed_wrapper_d3ew_p_nested_target
	PROPERTY
	PROJECT_LABEL
	"DCubed d3ew_p Wrapper Library")

=== debian/changelog ===
supertuxkart (1.1+ds-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:27:02 +0100

supertuxkart (1.1+ds-1) unstable; urgency=medium

  * Team upload.
  * Update d/watch to version 4 and add repacksuffix.
  * Re-add embedded copy/fork of enet.
  * Enable IPv6 support.
  * Drop sources of files from missing-sources that are no longer shipped.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sun, 12 Jan 2020 13:37:31 +0100

=== debian/control ===
Source: supertuxkart
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Sam Hocevar <sho@debian.org>,
 Vincent Cheng <vcheng@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 libalut-dev,
 libbluetooth-dev [linux-any],
 libbz2-dev,
 libcurl4-gnutls-dev | libcurl4-dev,
 libegl1-mesa-dev,
 libfreetype6-dev,
 libfribidi-dev,
 libgl1-mesa-dev,
 libgles2-mesa-dev,
 libglu1-mesa-dev,
 libglew-dev,
 libharfbuzz-dev,
 libjpeg-dev,
 libmcpp-dev,
 libopenal-dev,
 libpng-dev,
 libraqm-dev,
 libsqlite3-dev,
 libsquish-dev,
 libvorbis-dev,
 libwayland-dev,
 libxkbcommon-dev,
 libxrandr-dev,
 libxxf86vm-dev,
 mesa-common-dev,
 nettle-dev,
 pkg-config,
 zlib1g-dev
Standards-Version: 4.4.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/games-team/supertuxkart.git
Vcs-Browser: https://salsa.debian.org/games-team/supertuxkart
Homepage: https://supertuxkart.net

Package: supertuxkart
Architecture: any
Depends:
 supertuxkart-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: 3D arcade racer with a variety of characters, tracks, and modes to play
 Karts. Nitro. Action! SuperTuxKart is a 3D open-source arcade racer with a
 variety of characters, tracks, and modes to play. The aim is to create a
 game that is more fun than realistic, and provide an enjoyable experience
 for all ages.
 .
 Discover the mystery of an underwater world, or drive through the jungles
 of Val Verde and visit the famous Cocoa Temple. Race underground or in a
 spaceship, through a rural farmland or a strange alien planet.
 Or rest under the palm trees on the beach, watching the other karts
 overtake you. But don't eat the bananas! Watch for bowling balls,
 plungers, bubble gum, and cakes thrown by your opponents.
 .
 You can do a single race against other karts, compete in one of several
 Grand Prix, try to beat the high score in time trials on your own, play
 battle mode against the computer or your friends, and more! For a greater
 challenge, race online against players from all over the world and prove
 your racing prowess!

Package: supertuxkart-data
Architecture: all
Multi-Arch: foreign
Depends:
 fonts-cantarell,
 fonts-noto-color-emoji,
 fonts-noto-core,
 fonts-noto-ui-core,
 ${misc:Depends}
Suggests:
 supertuxkart
Description: 3D arcade racer with a variety of characters, tracks, and modes to play (data)
 Karts. Nitro. Action! SuperTuxKart is a 3D open-source arcade racer with a
 variety of characters, tracks, and modes to play. The aim is to create a
 game that is more fun than realistic, and provide an enjoyable experience
 for all ages.
 .
 Discover the mystery of an underwater world, or drive through the jungles
 of Val Verde and visit the famous Cocoa Temple. Race underground or in a
 spaceship, through a rural farmland or a strange alien planet.
 Or rest under the palm trees on the beach, watching the other karts
 overtake you. But don't eat the bananas! Watch for bowling balls,
 plungers, bubble gum, and cakes thrown by your opponents.
 .
 You can do a single race against other karts, compete in one of several
 Grand Prix, try to beat the high score in time trials on your own, play
 battle mode against the computer or your friends, and more! For a greater
 challenge, race online against players from all over the world and prove
 your racing prowess!
 .
 This package contains data files for SuperTuxKart.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_LDFLAGS_MAINT_APPEND=-lGLU

%:
	dh $@ --buildsystem=cmake

override_dh_auto_clean:
	# Remove embedded libraries used by embedded Irrlicht
	rm -rf lib/glew/
	rm -rf lib/mcpp/
	rm -rf lib/jpeglib/
	rm -rf lib/libpng/
	rm -rf lib/libraqm/
	rm -rf lib/libsquish/
	rm -rf lib/zlib/

	dh_auto_clean

override_dh_auto_configure:
	# libbluetooth-dev is only available on linux, hence build with
	# wiimote input device support only on linux
	# TODO: remove -DBUILD_RECORDER=0 once libopenglrecorder is packaged
	if [ $(DEB_HOST_ARCH_OS) = linux ]; then \
	dh_auto_configure -- -DCMAKE_BUILD_TYPE="STKRelease" \
	                     -DSTK_INSTALL_BINARY_DIR="games" \
	                     -DSTK_INSTALL_DATA_DIR="share/games/supertuxkart" \
	                     -DUSE_CRYPTO_OPENSSL=OFF \
	                     -DBUILD_RECORDER=0; \
	else \
	dh_auto_configure -- -DCMAKE_BUILD_TYPE="STKRelease" \
	                     -DSTK_INSTALL_BINARY_DIR="games" \
	                     -DSTK_INSTALL_DATA_DIR="share/games/supertuxkart" \
	                     -DUSE_WIIUSE=OFF \
	                     -DUSE_CRYPTO_OPENSSL=OFF \
	                     -DBUILD_RECORDER=0; \
	fi

override_dh_install:
	# Licenses are all documented in debian/copyright
	find $(CURDIR)/debian/tmp \( \
	 -iname "LICENSE" \
	 -o -iname "License.txt" \
	 -o -iname "licence2.txt" \
	 -o -iname "Music_license.rtf" \
	 -o -iname "licenses.txt" \
	 -o -name "SIL Open Font License.txt" \
	\) -delete

	# Remove unneeded (developer) scripts and other files in data directory
	find $(CURDIR)/debian/tmp/usr/share/games/supertuxkart/data \( \
	 -name "optimize_data.sh" \
	 -o -name "pull_from_transifex.sh" \
	 -o -name "supertuxkart.appdata.xml" \
	 -o -name "supertuxkart.desktop" \
	 -o -name "*.icns" \
	 -o -name "*.plist" \
	 \) -delete

	dh_install -Xgitignore -Xgitattributes

override_dh_strip:
	dh_strip --dbgsym-migration='supertuxkart-dbg (<< 1.0-1~)'

=== debian/watch ===
version=4
opts="dversionmangle=auto, \
      uversionmangle=s/-rc/~rc/, \
      repacksuffix=+ds" \
https://sf.net/supertuxkart/supertuxkart-@ANY_VERSION@-src@ARCHIVE_EXT@
